1. first bug. 
#inlcude <stdlib.h>
instead of 
#include <stdio.h>
which cause Segmentation fault (core dump).

2. misconception of union.
try to judge whether one possible field is NULL, did not realize that
no matter which field we use when assign the value to union. when we read
from the union from any filed, it is not NULL, because all the field
are shared in the same memory location.
 
3. VIM use .swp file. sometime ti cause confusion. fortunately, it did not
cause real harm.
